import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import org.lwjgl.input.Keyboard;

public class JPCTKeyboard extends KeyAdapter {
	
	private static boolean opengl = false;
	private static JPCTKeyboard keyboard = null;
	private static int[] AWTKeys = {KeyEvent.VK_0, KeyEvent.VK_1, KeyEvent.VK_2,
									KeyEvent.VK_3, KeyEvent.VK_4, KeyEvent.VK_5,
									KeyEvent.VK_6, KeyEvent.VK_7, KeyEvent.VK_8,
									KeyEvent.VK_9, KeyEvent.VK_A, KeyEvent.VK_B,
									KeyEvent.VK_C, KeyEvent.VK_D, KeyEvent.VK_E,
									KeyEvent.VK_F, KeyEvent.VK_G, KeyEvent.VK_H,
									KeyEvent.VK_I, KeyEvent.VK_J, KeyEvent.VK_K,
									KeyEvent.VK_L, KeyEvent.VK_M, KeyEvent.VK_N,
									KeyEvent.VK_O, KeyEvent.VK_P, KeyEvent.VK_Q,
									KeyEvent.VK_R, KeyEvent.VK_S, KeyEvent.VK_T,
									KeyEvent.VK_U, KeyEvent.VK_V, KeyEvent.VK_W,
									KeyEvent.VK_X, KeyEvent.VK_Y, KeyEvent.VK_Z,
									KeyEvent.VK_F1, KeyEvent.VK_F2, KeyEvent.VK_F3,
									KeyEvent.VK_F4, KeyEvent.VK_F5, KeyEvent.VK_F6,
									KeyEvent.VK_F7, KeyEvent.VK_F8, KeyEvent.VK_F9,
									KeyEvent.VK_F10, KeyEvent.VK_F11, KeyEvent.VK_F12,
									KeyEvent.VK_UP,  KeyEvent.VK_DOWN, KeyEvent.VK_LEFT, 
									KeyEvent.VK_RIGHT,  KeyEvent.VK_INSERT, KeyEvent.VK_HOME,
									KeyEvent.VK_PAGE_UP, KeyEvent.VK_DELETE, KeyEvent.VK_END, 
									KeyEvent.VK_PAGE_DOWN, KeyEvent.VK_CONTROL, KeyEvent.VK_SHIFT, 
									KeyEvent.VK_TAB, KeyEvent.VK_NUMPAD0, KeyEvent.VK_NUMPAD1, 
									KeyEvent.VK_NUMPAD2, KeyEvent.VK_NUMPAD3, KeyEvent.VK_NUMPAD4, 
									KeyEvent.VK_NUMPAD5, KeyEvent.VK_NUMPAD6, KeyEvent.VK_NUMPAD7, 
									KeyEvent.VK_NUMPAD8, KeyEvent.VK_NUMPAD9, KeyEvent.VK_NUM_LOCK, 
									KeyEvent.VK_SCROLL_LOCK, KeyEvent.VK_PAUSE, KeyEvent.VK_ESCAPE, 
									KeyEvent.VK_ENTER, KeyEvent.VK_BACK_SPACE, KeyEvent.VK_SPACE, 
									KeyEvent.VK_MINUS, KeyEvent.VK_PLUS, KeyEvent.VK_MULTIPLY, 
									KeyEvent.VK_DIVIDE, KeyEvent.VK_COMMA, KeyEvent.VK_PERIOD};
									
	private static int[] LWJGLKeys = {Keyboard.KEY_0, Keyboard.KEY_1, Keyboard.KEY_2,
									  Keyboard.KEY_3, Keyboard.KEY_4, Keyboard.KEY_5,
									  Keyboard.KEY_6, Keyboard.KEY_7, Keyboard.KEY_8,
									  Keyboard.KEY_9, Keyboard.KEY_A, Keyboard.KEY_B,
									  Keyboard.KEY_C, Keyboard.KEY_D, Keyboard.KEY_E,
									  Keyboard.KEY_F, Keyboard.KEY_G, Keyboard.KEY_H,
									  Keyboard.KEY_I, Keyboard.KEY_J, Keyboard.KEY_K,
									  Keyboard.KEY_L, Keyboard.KEY_M, Keyboard.KEY_N,
									  Keyboard.KEY_O, Keyboard.KEY_P, Keyboard.KEY_Q,
									  Keyboard.KEY_R, Keyboard.KEY_S, Keyboard.KEY_T,
									  Keyboard.KEY_U, Keyboard.KEY_V, Keyboard.KEY_W,
									  Keyboard.KEY_X, Keyboard.KEY_Y, Keyboard.KEY_Z,
									  Keyboard.KEY_F1, Keyboard.KEY_F2, Keyboard.KEY_F3,
									  Keyboard.KEY_F4, Keyboard.KEY_F5, Keyboard.KEY_F6,
									  Keyboard.KEY_F7, Keyboard.KEY_F8, Keyboard.KEY_F9,
									  Keyboard.KEY_F10, Keyboard.KEY_F11, Keyboard.KEY_F12,
									  Keyboard.KEY_UP, Keyboard.KEY_DOWN, Keyboard.KEY_LEFT,
									  Keyboard.KEY_RIGHT, Keyboard.KEY_INSERT, Keyboard.KEY_HOME,
									  Keyboard.KEY_NEXT, Keyboard.KEY_DELETE, Keyboard.KEY_END, 
									  Keyboard.KEY_PRIOR, Keyboard.KEY_LCONTROL, Keyboard.KEY_LSHIFT, 
									  Keyboard.KEY_TAB, Keyboard.KEY_NUMPAD0, Keyboard.KEY_NUMPAD1, 
									  Keyboard.KEY_NUMPAD2, Keyboard.KEY_NUMPAD3, Keyboard.KEY_NUMPAD4, 
									  Keyboard.KEY_NUMPAD5, Keyboard.KEY_NUMPAD6, Keyboard.KEY_NUMPAD7, 
									  Keyboard.KEY_NUMPAD8, Keyboard.KEY_NUMPAD9, Keyboard.KEY_NUMLOCK, 
									  Keyboard.KEY_SCROLL, Keyboard.KEY_PAUSE, Keyboard.KEY_ESCAPE, 
									  Keyboard.KEY_RETURN, Keyboard.KEY_BACK, Keyboard.KEY_SPACE, 
									  Keyboard.KEY_MINUS, Keyboard.KEY_PRIOR, Keyboard.KEY_MULTIPLY, 
									  Keyboard.KEY_DIVIDE, Keyboard.KEY_COMMA, Keyboard.KEY_PERIOD, 
									  Keyboard.KEY_RCONTROL, Keyboard.KEY_RSHIFT};									

	private static boolean[] JPCTKeys = new boolean[85];
	
	public final static int JPCTKEY_0 = 0;
	public final static int JPCTKEY_1 = 1;
	public final static int JPCTKEY_2 = 2;
	public final static int JPCTKEY_3 = 3;
	public final static int JPCTKEY_4 = 4;
	public final static int JPCTKEY_5 = 5;
	public final static int JPCTKEY_6 = 6;
	public final static int JPCTKEY_7 = 7;
	public final static int JPCTKEY_8 = 8;
	public final static int JPCTKEY_9 = 9;
	public final static int JPCTKEY_A = 10;
	public final static int JPCTKEY_B = 11;
	public final static int JPCTKEY_C = 12;
	public final static int JPCTKEY_D = 13;
	public final static int JPCTKEY_E = 14;
	public final static int JPCTKEY_F = 15;
	public final static int JPCTKEY_G = 16;
	public final static int JPCTKEY_H = 17;
	public final static int JPCTKEY_I = 18;
	public final static int JPCTKEY_J = 19;
	public final static int JPCTKEY_K = 20;
	public final static int JPCTKEY_L = 21;
	public final static int JPCTKEY_M = 22;
	public final static int JPCTKEY_N = 23;
	public final static int JPCTKEY_O = 24;
	public final static int JPCTKEY_P = 25;
	public final static int JPCTKEY_Q = 26;
	public final static int JPCTKEY_R = 27;
	public final static int JPCTKEY_S = 28;
	public final static int JPCTKEY_T = 29;
	public final static int JPCTKEY_U = 30;
	public final static int JPCTKEY_V = 31;
	public final static int JPCTKEY_W = 32;
	public final static int JPCTKEY_X = 33;
	public final static int JPCTKEY_Y = 34;
	public final static int JPCTKEY_Z = 35;
	public final static int JPCTKEY_F1 = 36;
	public final static int JPCTKEY_F2 = 37;
	public final static int JPCTKEY_F3 = 38;
	public final static int JPCTKEY_F4 = 39;
	public final static int JPCTKEY_F5 = 40;
	public final static int JPCTKEY_F6 = 41;
	public final static int JPCTKEY_F7 = 42;
	public final static int JPCTKEY_F8 = 43;
	public final static int JPCTKEY_F9 = 44;
	public final static int JPCTKEY_F10 = 45;
	public final static int JPCTKEY_F11 = 46;
	public final static int JPCTKEY_F12 = 47;
	public final static int JPCTKEY_UP = 48;
	public final static int JPCTKEY_DOWN = 49;
	public final static int JPCTKEY_LEFT = 50;
	public final static int JPCTKEY_RIGHT = 51;
	public final static int JPCTKEY_INSERT = 52;
	public final static int JPCTKEY_HOME = 53;
	public final static int JPCTKEY_PAGE_UP = 54;
	public final static int JPCTKEY_DELETE = 55;
	public final static int JPCTKEY_END = 56;
	public final static int JPCTKEY_PAGE_DOWN = 57;
	public final static int JPCTKEY_LCTRL = 58;
	public final static int JPCTKEY_RCTRL = 84;
	public final static int JPCTKEY_LSHIFT = 59;
	public final static int JPCTKEY_RSHIFT = 85;
	public final static int JPCTKEY_TAB = 60;
	public final static int JPCTKEY_NUMPAD_0 = 61;
	public final static int JPCTKEY_NUMPAD_1 = 62;
	public final static int JPCTKEY_NUMPAD_2 = 63;
	public final static int JPCTKEY_NUMPAD_3 = 64;
	public final static int JPCTKEY_NUMPAD_4 = 65;
	public final static int JPCTKEY_NUMPAD_5 = 66;
	public final static int JPCTKEY_NUMPAD_6 = 67;
	public final static int JPCTKEY_NUMPAD_7 = 68;
	public final static int JPCTKEY_NUMPAD_8 = 69;
	public final static int JPCTKEY_NUMPAD_9 = 70;
	public final static int JPCTKEY_NUMLOCK = 71;
	public final static int JPCTKEY_SCROLL = 72;
	public final static int JPCTKEY_PAUSE = 73;
	public final static int JPCTKEY_ESC = 74;
	public final static int JPCTKEY_ENTER = 75;
	public final static int JPCTKEY_BACK = 76;
	public final static int JPCTKEY_SPACE = 77;
	public final static int JPCTKEY_MINUS = 78;
	public final static int JPCTKEY_PLUS = 79;
	public final static int JPCTKEY_MULTIPLY = 80;
	public final static int JPCTKEY_DIVIDE = 81;
	public final static int JPCTKEY_COMMA = 82;
	public final static int JPCTKEY_PERIOD = 83;
	
	private JPCTKeyboard() {
		for (int i=0; i<JPCTKeys.length; i++)
			JPCTKeys[i] = false;
			System.out.println("Keyboard created...");
	}
	
	private void processKey(KeyEvent ke, boolean status) {
		System.out.println(ke.getKeyCode() + " " + ke.getKeyLocation());
		for (int i = 0; i < AWTKeys.length; i++)
			if (ke.getKeyCode() == AWTKeys[i]) 
				if (ke.getKeyLocation() != 3)
					JPCTKeys[i] = status;
				else
					JPCTKeys[i+26] = status;
	}
	
	public static void create() {
		if (keyboard == null)
			keyboard = new JPCTKeyboard();
		else 
			System.out.println("Keyboard already created...");		
	}
	
	public static JPCTKeyboard getInstance() {
		return keyboard;
	}
	
	public static void createLWJGLKeyboard() {
		if (!Keyboard.isCreated())
			try {
				Keyboard.create();
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
	
	public static void destroyLWJGLKeyboard() {
		if (Keyboard.isCreated())
			try {
				Keyboard.destroy();
			} catch (Exception e) {
				e.printStackTrace();	
			}
	}
	
	public void keyPressed(KeyEvent ke) {
		System.out.println(ke.getKeyCode());
		processKey(ke, true);
	}
	
	public void keyReleased(KeyEvent ke) {
		processKey(ke, false);	
	}
	
	public static void keybPoll() {
		if (opengl) {
			Keyboard.poll();
			for (int i = 0; i < LWJGLKeys.length; i++)
				if (Keyboard.isKeyDown(LWJGLKeys[i])) 
					JPCTKeys[i] = true;
				else
					JPCTKeys[i] = false;
		}				
	}
	
	public static void setSoftRenderer(boolean rend) {
		opengl = !rend;
	}
	
	public static boolean isKeyPressed(int key) {
		return JPCTKeys[key];
	}
}
