import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import org.lwjgl.input.Keyboard;

public class TestWrapper extends KeyAdapter {
	
	private boolean opengl = false;
	private boolean[] keys;
	
	public TestWrapper() {
		keys = new boolean[5];
		for (int i=0; i<5; i++)
			keys[i] = false;
	}
	
	public void createKeyboard() {
		if (!Keyboard.isCreated())
			try {
				Keyboard.create();
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
	
	public void destroyKeyboard() {
		if (Keyboard.isCreated())
			try {
				Keyboard.destroy();
			} catch (Exception e) {
				e.printStackTrace();	
			}
	}
	
	public void keyPressed(KeyEvent ke) {
		switch (ke.getKeyCode()) {
			case KeyEvent.VK_UP: 
				keys[0] = true;
				break;
			case KeyEvent.VK_DOWN:
				keys[1] = true;
				break;
			case KeyEvent.VK_LEFT:
				keys[2] = true;
				break;
			case KeyEvent.VK_RIGHT:
				keys[3] = true;
				break;
						
		}	
	}
	
	public void keyReleased(KeyEvent ke) {
		switch (ke.getKeyCode()) {
			case KeyEvent.VK_UP: 
				keys[0] = false;
				break;
			case KeyEvent.VK_DOWN:
				keys[1] = false;
				break;
			case KeyEvent.VK_LEFT:
				keys[2] = false;
				break;
			case KeyEvent.VK_RIGHT:
				keys[3] = false;
				break;
		}	
	}
	
	public boolean keyUP() {
		return keys[0];
	}
	
	public boolean keyDOWN() {
		return keys[1];
	}
	
	public boolean keyLEFT() {
		return keys[2];
	}
		
	public boolean keyRIGHT() {
		return keys[3];
	}
	
	public void keybPoll() {
		if (opengl) {
			Keyboard.poll();
			if (Keyboard.isKeyDown(Keyboard.KEY_UP))
				keys[0] = true;
			else
				keys[0] = false;	
			if (Keyboard.isKeyDown(Keyboard.KEY_DOWN))
				keys[1] = true;	
			else
				keys[1] = false;				
			if (Keyboard.isKeyDown(Keyboard.KEY_LEFT))
				keys[2] = true;	
			else
				keys[2] = false;				
			if (Keyboard.isKeyDown(Keyboard.KEY_RIGHT))
				keys[3] = true;				
			else
				keys[3] = false;		
		}		
	}
	
	public void setSoftRenderer(boolean rend) {
		opengl = !rend;
	}
}
